#include <VirtualWire.h>              //Download it here: http://electronoobs.com/eng_arduino_virtualWire.php
byte messageLength = VW_MAX_MESSAGE_LEN; // the size of the message
int BUZZER_PIN = 8; // buzzer sound
int SIGNAL_PIN = 2; // radio signal

unsigned long last_time = 0;
uint32_t lastrange = 3000;
int led_a = HIGH;
int led_b = LOW;

void setup()
{
  Serial.begin(9600);
  vw_set_rx_pin(SIGNAL_PIN); // pin
  vw_setup(2000); // bps
  vw_rx_start();

  pinMode(BUZZER_PIN, OUTPUT);
  pinMode(LED_BUILTIN, OUTPUT);

  //tone(BUZZER_PIN, 1000, 2000);
  randomSeed(123);
}
void loop()
{
  unsigned long time;
  
  if (vw_get_message((uint8_t *)&time, &messageLength)) // non-blocking
  {
    if (last_time == 0) {
      last_time = time;
    }
    else {
      unsigned long del = time - last_time;
      last_time = time;
      Serial.println(del);
      dosimeter_sound(del);
    }
  }
  else {
    delay(10);
  }
}


void dosimeter_sound(unsigned long distance) {
  int freq = random (350,550);      // random tone frequency
    tone(BUZZER_PIN, freq);   // Send sound signal
    delay(10);            // for 10 ms
    noTone(BUZZER_PIN);       // Stop sound

    lastrange = distance;

    digitalWrite(LED_BUILTIN, led_a);
    // random additional time delay
    int r = random (1,150);
    if(r >= 30){
      if(lastrange > 3000){ 
        r = random (1,500);
        delay(r + 1000);
      }else{
        r = random (1,50);
        delay(r + lastrange/3);
      }
    }
    digitalWrite(LED_BUILTIN, led_b);
    int tmp = led_a;
    led_a = led_b;
    led_b = tmp;
}
